diff -pruN 1.1.0-1-geeac494-6.1/config 1.2.3-1/config
--- 1.1.0-1-geeac494-6.1/config	2012-04-26 15:13:13.000000000 +0000
+++ 1.2.3-1/config	2015-04-09 10:41:48.000000000 +0000
@@ -1,10 +1,10 @@
 # Installation directories
 # System's libraries directory (where binary libraries are installed)
-LUA_LIBDIR= /usr/local/lib/lua/5.0
+LUA_LIBDIR= /usr/lib/lua/5.1
 # Lua includes directory
-LUA_INC= /usr/local/include
+LUA_INC= /usr/include/lua5.1
 # OpenLDAP includes directory
-OPENLDAP_INC= /usr/local/include
+OPENLDAP_INC= /usr/include
 # OpenLDAP library (an optional directory can be specified with -L<dir>)
 OPENLDAP_LIB= -lldap
 
@@ -13,7 +13,7 @@ LIB_OPTION= -shared #for Linux
 #LIB_OPTION= -bundle -undefined dynamic_lookup #for MacOS X
 
 # Lua version number (first and second digits of target version)
-LUA_VERSION_NUM= 500
+LUA_VERSION_NUM= 501
 LIBNAME= $T.so.$V
 COMPAT_DIR= ../compat/src
 
diff -pruN 1.1.0-1-geeac494-6.1/CONTRIBUTORS.md 1.2.3-1/CONTRIBUTORS.md
--- 1.1.0-1-geeac494-6.1/CONTRIBUTORS.md	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.3-1/CONTRIBUTORS.md	2015-04-09 10:41:48.000000000 +0000
@@ -0,0 +1,13 @@
+LuaLDAP was released originally by [Kepler Project](http://www.keplerproject.org/lualdap/) but the URL no longer responds
+
+A CVS to Git conversion done by [LuaForge](http://luaforge.net/projects/lualdap/) pointing at [Github](https://github.com/luaforge/lualdap) as the source
+A note was added to the project that if you were the maintainer then send them an email to luaforge@gmail.com to reroot it.
+
+Significant contributions were made by:
+
+ * [Matthew Wild](https://github.com/mwild1) - Cleanup and LDAP API 2.3 update
+ * [Dennis Schridde](https://github.com/devurandom) - Cleanup and LDAP API 2.3 update
+ * [Vadim A. Misbakh-Soloviov](https://github.com/msva) - Assert fix
+ * Michael Bienia, Micah Gersten <micahg@ubuntu.com>, Luca Capello <luca@pca.it> - https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=722175
+ * [John Regan](https://github.com/jprjr) - initial Rockspec and apply [Debian bugfix](https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=722175)
+ * [Brett Delle Grazie](https://github.com/bdellegrazie) - application of [Prosody](http://prosody.im) [patch](http://prosody.im/patches/lualdap.patch), documentation updates
diff -pruN 1.1.0-1-geeac494-6.1/debian/changelog 1.2.3-1/debian/changelog
--- 1.1.0-1-geeac494-6.1/debian/changelog	2018-01-20 20:29:02.000000000 +0000
+++ 1.2.3-1/debian/changelog	2018-12-06 23:49:54.000000000 +0000
@@ -1,3 +1,19 @@
+lua-ldap (1.2.3-1) unstable; urgency=medium
+
+  * add debian/.gitlab-ci.yml file
+  * add myself as Maintainer with Luca's permission
+  * update Vcs-* due migration to salsa
+  * update debian/gbp.conf
+  * change upstream to https://github.com/lualdap/lualdap
+  * New upstream version 1.2.3
+  * add support for lua5.2 (Closes: #814218,#914530)
+  * update compat to 10
+  * update standards-version to 4.2.1, no changes needed
+  * add doc-base control file for html docs
+  * remove privacy-breach-* problems with html docs
+
+ -- Victor Seva <vseva@debian.org>  Fri, 07 Dec 2018 00:49:54 +0100
+
 lua-ldap (1.1.0-1-geeac494-6.1) unstable; urgency=medium
 
   * Non-maintainer upload.
@@ -52,7 +68,7 @@ lua-ldap (1.1.0-1-geeac494-2) unstable;
     + move to collab-maint.
   * debian/watch:
     + adapt to GitHub downloads.
-  
+
   [ Luca Capello ]
   * debian/copyright:
     + add Enrico Tassi for the debian/* files.
diff -pruN 1.1.0-1-geeac494-6.1/debian/compat 1.2.3-1/debian/compat
--- 1.1.0-1-geeac494-6.1/debian/compat	2014-08-31 16:44:37.000000000 +0000
+++ 1.2.3-1/debian/compat	2018-12-06 23:49:54.000000000 +0000
@@ -1 +1 @@
-9
+10
diff -pruN 1.1.0-1-geeac494-6.1/debian/control 1.2.3-1/debian/control
--- 1.1.0-1-geeac494-6.1/debian/control	2018-01-20 20:29:02.000000000 +0000
+++ 1.2.3-1/debian/control	2018-12-06 23:49:54.000000000 +0000
@@ -1,20 +1,28 @@
 Source: lua-ldap
 Section: interpreters
 Priority: optional
-Maintainer: Luca Capello <luca@pca.it>
-Uploaders: Enrico Tassi <gareuselesinge@debian.org>
-Build-Depends: debhelper (>= 9), dh-lua (>= 12), libldap2-dev
-Standards-Version: 3.9.5
-Vcs-Git: git://anonscm.debian.org/collab-maint/lua-ldap.git -b debian
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/lua-ldap.git
-Homepage: https://github.com/luaforge/lualdap
+Maintainer: Victor Seva <vseva@debian.org>
+Uploaders:
+ Enrico Tassi <gareuselesinge@debian.org>,
+Build-Depends:
+ debhelper (>= 10),
+ dh-lua (>= 12),
+ libldap2-dev,
+Standards-Version: 4.2.1
+Vcs-Git: https://salsa.debian.org/lua-team/lua-ldap.git
+Vcs-Browser: https://salsa.debian.org/lua-team/lua-ldap
+Homepage: https://github.com/lualdap/lualdap
 
 Package: lua-ldap
 Architecture: any
 Multi-Arch: same
-Pre-Depends: ${misc:Pre-Depends}
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Provides: ${lua:Provides}
+Pre-Depends:
+ ${misc:Pre-Depends},
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+Provides:
+ ${lua:Provides},
 XB-Lua-Versions: ${lua:Versions}
 Description: LDAP library for the Lua language
  This package contains the Lua LDAP library to:
@@ -28,9 +36,13 @@ Description: LDAP library for the Lua la
 Package: lua-ldap-dev
 Architecture: any
 Multi-Arch: same
-Pre-Depends: ${misc:Pre-Depends}
-Depends: lua-ldap (= ${binary:Version}), ${misc:Depends}
-Provides: ${lua:Provides}
+Pre-Depends:
+ ${misc:Pre-Depends},
+Depends:
+ lua-ldap (= ${binary:Version}),
+ ${misc:Depends},
+Provides:
+ ${lua:Provides},
 XB-Lua-Versions: ${lua:Versions}
 Section: libdevel
 Description: LDAP development files for the Lua language
diff -pruN 1.1.0-1-geeac494-6.1/debian/copyright 1.2.3-1/debian/copyright
--- 1.1.0-1-geeac494-6.1/debian/copyright	2014-08-31 16:44:37.000000000 +0000
+++ 1.2.3-1/debian/copyright	2018-12-06 23:49:54.000000000 +0000
@@ -5,6 +5,9 @@ Source: https://github.com/luaforge/lual
 
 Files: *
 Copyright: 2003-2007 The Kepler project
+           2012-2018 Dennis Schridde
+           2014 Brett Delle Grazie
+           2017 Jakub Jirutka
 Comment: In the Lua community this license is better known as "MIT".
   Unfortunately other variants of this license are also known as "MIT".
   To obtain a machine intepretable copyright file Debian prefers to name this
@@ -14,6 +17,7 @@ License: Expat
 Files: debian/*
 Copyright: 2012 Luca Capello <luca@pca.it>
            2012 Enrico Tassi <gareuselesinge@debian.org>
+           2018 Victor Seva  <vseva@debian.org>
 License: Expat
 
 License: Expat
diff -pruN 1.1.0-1-geeac494-6.1/debian/dh-lua.conf 1.2.3-1/debian/dh-lua.conf
--- 1.1.0-1-geeac494-6.1/debian/dh-lua.conf	2014-08-31 16:44:37.000000000 +0000
+++ 1.2.3-1/debian/dh-lua.conf	1970-01-01 00:00:00.000000000 +0000
@@ -1,22 +0,0 @@
-LUA_VERSION=5.1
-PKG_NAME=ldap
-
-# pkg-config support is missing from upstream OpenLDAP
-# <http://bugs.debian.org/670824>
-CLIB_CFLAGS=
-CLIB_LDFLAGS=-lldap
-CLIB_LDFLAGS_STATIC=-lldap -llber
-CLIB_OBJS=src/lualdap.lo
-
-LUA_HEADER=
-LUA_SOURCES=
-LUA_MODNAME=lualdap
-# testing requires an LDAP server
-#LUA_TEST=cd tests/ && @@LUA@@ test.lua
-LUA_MODNAME_CPART=
-
-PKG_VERSION=$(shell dpkg-parsechangelog|grep ^Ver|cut -d ' ' -f 2|cut -d '-' -f 1)
-PKG_LIBS_PRIVATE=
-PKG_URL=https://github.com/luaforge/lualdap
-PKG_REQUIRES=
-PKG_CONFLICTS=
diff -pruN 1.1.0-1-geeac494-6.1/debian/gbp.conf 1.2.3-1/debian/gbp.conf
--- 1.1.0-1-geeac494-6.1/debian/gbp.conf	2014-08-31 16:44:37.000000000 +0000
+++ 1.2.3-1/debian/gbp.conf	2018-12-06 23:49:54.000000000 +0000
@@ -1,4 +1,2 @@
 [DEFAULT]
-upstream-branch = master
-debian-branch = debian
 pristine-tar = true
diff -pruN 1.1.0-1-geeac494-6.1/debian/.gitlab-ci.yml 1.2.3-1/debian/.gitlab-ci.yml
--- 1.1.0-1-geeac494-6.1/debian/.gitlab-ci.yml	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.3-1/debian/.gitlab-ci.yml	2018-12-06 23:49:54.000000000 +0000
@@ -0,0 +1,16 @@
+include: https://salsa.debian.org/salsa-ci-team/pipeline/raw/master/salsa-ci.yml
+
+build:
+    extends: .build-unstable
+
+reprotest:
+    extends: .test-reprotest
+
+lintian:
+    extends: .test-lintian
+
+autopkgtest:
+    extends: .test-autopkgtest
+
+piuparts:
+    extends: .test-piuparts
diff -pruN 1.1.0-1-geeac494-6.1/debian/lua5.1.dh-lua.conf 1.2.3-1/debian/lua5.1.dh-lua.conf
--- 1.1.0-1-geeac494-6.1/debian/lua5.1.dh-lua.conf	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.3-1/debian/lua5.1.dh-lua.conf	2018-12-06 23:49:54.000000000 +0000
@@ -0,0 +1,21 @@
+PKG_NAME=ldap
+
+# pkg-config support is missing from upstream OpenLDAP
+# <http://bugs.debian.org/670824>
+CLIB_CFLAGS=
+CLIB_LDFLAGS=-lldap
+CLIB_LDFLAGS_STATIC=-lldap -llber
+CLIB_OBJS=src/lualdap.lo
+
+LUA_HEADER=
+LUA_SOURCES=
+LUA_MODNAME=lualdap
+# testing requires an LDAP server
+#LUA_TEST=cd tests/ && @@LUA@@ test.lua
+LUA_MODNAME_CPART=
+
+PKG_VERSION=$(shell dpkg-parsechangelog|grep ^Ver|cut -d ' ' -f 2|cut -d '-' -f 1)
+PKG_LIBS_PRIVATE=
+PKG_URL=https://github.com/lualdap/lualdap
+PKG_REQUIRES=
+PKG_CONFLICTS=
diff -pruN 1.1.0-1-geeac494-6.1/debian/lua5.2.dh-lua.conf 1.2.3-1/debian/lua5.2.dh-lua.conf
--- 1.1.0-1-geeac494-6.1/debian/lua5.2.dh-lua.conf	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.3-1/debian/lua5.2.dh-lua.conf	2018-12-06 23:49:54.000000000 +0000
@@ -0,0 +1,21 @@
+PKG_NAME=ldap
+
+# pkg-config support is missing from upstream OpenLDAP
+# <http://bugs.debian.org/670824>
+CLIB_CFLAGS=
+CLIB_LDFLAGS=-lldap
+CLIB_LDFLAGS_STATIC=-lldap -llber
+CLIB_OBJS=src/lualdap.lo
+
+LUA_HEADER=
+LUA_SOURCES=
+LUA_MODNAME=lualdap
+# testing requires an LDAP server
+#LUA_TEST=cd tests/ && @@LUA@@ test.lua
+LUA_MODNAME_CPART=
+
+PKG_VERSION=$(shell dpkg-parsechangelog|grep ^Ver|cut -d ' ' -f 2|cut -d '-' -f 1)
+PKG_LIBS_PRIVATE=
+PKG_URL=https://github.com/lualdap/lualdap
+PKG_REQUIRES=
+PKG_CONFLICTS=
diff -pruN 1.1.0-1-geeac494-6.1/debian/lua-ldap-dev.doc-base 1.2.3-1/debian/lua-ldap-dev.doc-base
--- 1.1.0-1-geeac494-6.1/debian/lua-ldap-dev.doc-base	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.3-1/debian/lua-ldap-dev.doc-base	2018-12-06 23:49:54.000000000 +0000
@@ -0,0 +1,10 @@
+Document: lua-ldap
+Title: lua-ldap Manual
+Author: Kepler Project
+Abstract: Documentation from lua-ldap project
+Section: Programming
+
+Format: HTML
+Index: /usr/share/doc/lua-ldap-dev/us/index.html
+Files: /usr/share/doc/lua-ldap-dev/us/*.html
+
diff -pruN 1.1.0-1-geeac494-6.1/debian/patches/0002-add-doc-css.patch 1.2.3-1/debian/patches/0002-add-doc-css.patch
--- 1.1.0-1-geeac494-6.1/debian/patches/0002-add-doc-css.patch	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.3-1/debian/patches/0002-add-doc-css.patch	2018-12-06 23:49:54.000000000 +0000
@@ -0,0 +1,396 @@
+From: Victor Seva <vseva@debian.org>
+Date: Fri, 7 Dec 2018 00:17:42 +0100
+Subject: remove external reference on docs to remove privacy-breach-general
+
+---
+ doc/us/doc.css      | 226 ++++++++++++++++++++++++++++++++++++++++++++++++++++
+ doc/us/index.html   |   4 +-
+ doc/us/license.html |   4 +-
+ doc/us/manual.html  |  30 +++----
+ 4 files changed, 245 insertions(+), 19 deletions(-)
+ create mode 100644 doc/us/doc.css
+
+diff --git a/doc/us/doc.css b/doc/us/doc.css
+new file mode 100644
+index 0000000..39ae6ae
+--- /dev/null
++++ b/doc/us/doc.css
+@@ -0,0 +1,226 @@
++body { 
++    margin-left: 1em; 
++    margin-right: 1em; 
++    font-family: arial, helvetica, geneva, sans-serif;
++	background-color:#ffffff; margin:0px;
++}
++
++code {
++    font-family: "Andale Mono", monospace; 
++}
++
++tt {
++    font-family: "Andale Mono", monospace; 
++}
++
++body, td, th { font-size: 11pt; }
++
++h1, h2, h3, h4 { margin-left: 0em; }
++
++textarea, pre, tt { font-size:10pt; }
++body, td, th { color:#000000; }
++small { font-size:0.85em; }
++h1 { font-size:1.5em; }
++h2 { font-size:1.25em; }
++h3 { font-size:1.15em; }
++h4 { font-size:1.06em; }
++
++a:link { font-weight:bold; color: #004080; text-decoration: none; }
++a:visited { font-weight:bold; color: #006699; text-decoration: none; }
++a:link:hover { text-decoration:underline; }
++hr { color:#cccccc }
++img { border-width: 0px; }
++
++
++h3 { padding-top: 1em; }
++
++p { margin-left: 1em; }
++
++p.name { 
++    font-family: "Andale Mono", monospace; 
++    padding-top: 1em;
++    margin-left: 0em; 
++}
++
++blockquote { margin-left: 3em; }
++
++.example {
++    background-color: rgb(245, 245, 245);
++    border-top-width: 1px;
++    border-right-width: 1px;
++    border-bottom-width: 1px;
++    border-left-width: 1px;
++    border-top-style: solid;
++    border-right-style: solid;
++    border-bottom-style: solid;
++    border-left-style: solid;
++    border-top-color: silver;
++    border-right-color: silver;
++    border-bottom-color: silver;
++    border-left-color: silver;
++    padding: 1em;
++    margin-left: 1em;
++    margin-right: 1em;
++    font-family: "Andale Mono", monospace; 
++    font-size: smaller;
++}
++
++
++hr { 
++    margin-left: 0em;
++	background: #00007f; 
++	border: 0px;
++	height: 1px;
++}
++
++ul { list-style-type: disc; }
++
++table.index { border: 1px #00007f; }
++table.index td { text-align: left; vertical-align: top; }
++table.index ul { padding-top: 0em; margin-top: 0em; }
++
++table {
++    border: 1px solid black;
++	border-collapse: collapse;
++    margin-left: auto;
++    margin-right: auto;
++}
++th {
++    border: 1px solid black;
++    padding: 0.5em;
++}
++td {
++    border: 1px solid black;
++    padding: 0.5em;
++}
++div.header, div.footer { margin-left: 0em; }
++
++#container
++{
++	margin-left: 1em;
++	margin-right: 1em;
++	background-color: #f0f0f0;
++}
++
++#product
++{
++	text-align: center;
++	border-bottom: 1px solid #cccccc;
++	background-color: #ffffff;
++}
++
++#product big {
++	font-size: 2em;
++}
++
++#product_logo
++{
++}
++
++#product_name
++{
++}
++
++#product_description
++{
++}
++
++#main
++{
++	background-color: #f0f0f0;
++	border-left: 2px solid #cccccc;
++}
++
++#navigation
++{
++	float: left;
++	width: 12em;
++	margin: 0;
++	vertical-align: top;
++	background-color: #f0f0f0;
++	overflow:visible;
++}
++
++#navigation h1 {
++	background-color:#e7e7e7;
++	font-size:1.1em;
++	color:#000000;
++	text-align:left;
++	margin:0px;
++	padding:0.2em;
++	border-top:1px solid #dddddd;
++	border-bottom:1px solid #dddddd;
++}
++
++#navigation ul
++{
++	font-size:1em;
++	list-style-type: none;
++	padding: 0;
++	margin: 1px;
++}
++
++#navigation li
++{
++	text-indent: -1em;
++	margin: 0em 0em 0em 0.5em;
++	display: block;
++	padding: 3px 0px 0px 12px;
++}
++
++#navigation li li a
++{
++	padding: 0px 3px 0px -1em;
++}
++
++#content
++{
++	margin-left: 12em;
++	padding: 1em;
++	border-left: 2px solid #cccccc;
++	border-right: 2px solid #cccccc;
++	background-color: #ffffff;
++}
++
++#about
++{
++	clear: both;
++	margin: 0;
++	padding: 5px;
++	border-top: 2px solid #cccccc;
++	background-color: #ffffff;
++}
++
++@media print {
++	body { 
++		font: 10pt "Times New Roman", "TimeNR", Times, serif;
++	}
++	a { font-weight:bold; color: #004080; text-decoration: underline; }
++	
++	#main	{		background-color: #ffffff;		border-left: 0px;	}	
++	#container	{		margin-left: 2%;		margin-right: 2%;		background-color: #ffffff;	}
++	
++	#content	{		margin-left: 0px;		padding: 1em;		border-left: 0px;		border-right: 0px;		background-color: #ffffff;	}
++	
++	#navigation	{		display: none;
++	}
++	
++	#product_logo
++	{
++		display: none;
++	}
++
++	#about img
++	{
++		display: none;
++	}
++
++	.example {
++		font-family: "Andale Mono", monospace; 
++		font-size: 8pt;
++		page-break-inside: avoid;
++	}
++}
++
++/*
++     
+\ No newline at end of file
+diff --git a/doc/us/index.html b/doc/us/index.html
+index f8bce95..ecdc808 100644
+--- a/doc/us/index.html
++++ b/doc/us/index.html
+@@ -4,7 +4,7 @@
+ 
+ <head>
+     <title>LuaLDAP: A Lua interface to an LDAP library</title>
+-    <link rel="stylesheet" href="http://www.keplerproject.org/doc.css" type="text/css"/>
++    <link rel="stylesheet" href="doc.css" type="text/css"/>
+ 	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
+ </head>
+ 
+@@ -130,7 +130,7 @@ Comments are welcome!</p>
+ 
+ <div id="about">
+ 	<p><a href="http://validator.w3.org/check?uri=referer">
+-		<img src="http://www.w3.org/Icons/valid-xhtml10" alt="Valid XHTML 1.0!" height="31" width="88" /></a></p>
++	Valid XHTML 1.0!</p>
+ 	<p><small>$Id: index.html,v 1.37 2007-12-14 17:06:57 carregal Exp $</small></p>
+ </div> <!-- id="about" -->
+ 
+diff --git a/doc/us/license.html b/doc/us/license.html
+index 5b9ea9f..5ca67ce 100644
+--- a/doc/us/license.html
++++ b/doc/us/license.html
+@@ -4,7 +4,7 @@
+ 
+ <head>
+     <title>LuaLDAP: license</title>
+-    <link rel="stylesheet" href="http://www.keplerproject.org/doc.css" type="text/css"/>
++    <link rel="stylesheet" href="doc.css" type="text/css"/>
+ 	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
+ </head>
+ 
+@@ -111,7 +111,7 @@ SOFTWARE.</p>
+ 
+ <div id="about">
+ 	<p><a href="http://validator.w3.org/check?uri=referer">
+-		<img src="http://www.w3.org/Icons/valid-xhtml10" alt="Valid XHTML 1.0!" height="31" width="88" /></a></p>
++	Valid XHTML 1.0!</p>
+ 	<p><small>$Id: license.html,v 1.11 2007-12-14 16:46:15 carregal Exp $</small></p>
+ </div> <!-- id="about" -->
+ 
+diff --git a/doc/us/manual.html b/doc/us/manual.html
+index a9abd59..2f11a7b 100644
+--- a/doc/us/manual.html
++++ b/doc/us/manual.html
+@@ -4,7 +4,7 @@
+ 
+ <head>
+     <title>LuaLDAP: A Lua interface to an LDAP library</title>
+-    <link rel="stylesheet" href="http://www.keplerproject.org/doc.css" type="text/css"/>
++    <link rel="stylesheet" href="doc.css" type="text/css"/>
+ 	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
+ </head>
+ 
+@@ -106,7 +106,7 @@ which is not obtained from the installed software.
+ <h2><a name="installation"></a>Installation</h2>
+ 
+ <p>The LuaLDAP compiled binary should be copied to a directory in your
+-<a href="http://www.lua.org/manual/5.1/manual.html#pdf-package.cpath">C path</a>. 
++<a href="http://www.lua.org/manual/5.1/manual.html#pdf-package.cpath">C path</a>.
+ Lua 5.0 users should install <a href="http://www.keplerproject.org/compat">Compat-5.1</a> also.</p>
+ 
+ <p>Windows users of ADSI can use the binary versions of LuaLDAP
+@@ -201,23 +201,23 @@ message provided by the OpenLDAP client.</p>
+     table_of_attributes)</code></strong></dt>
+     <dd>Adds a new entry to the directory with the given attributes and
+     values. <a name="conn_close"></a></dd>
+-	
++
+     <dt><strong><code>conn:close()</code></strong></dt>
+     <dd>Closes the connection <code>conn</code>.</dd>
+-	
++
+     <dt><strong><code>conn:compare (distinguished_name, attribute,
+     value)</code></strong></dt>
+     <dd>Compares a value to an entry.</dd>
+-	
++
+     <dt><strong><code>conn:delete (distinguished_name)</code></strong></dt>
+     <dd>Deletes an entry from the directory.</dd>
+-	
++
+     <dt><strong><code>conn:modify (distinguished_name,
+     table_of_operations*)</code></strong></dt>
+     <dd>Changes the values of attributes in the given entry. The tables of
+     operations are <a href="#attributes">tables of attributes</a>
+     with the value on index <code>1</code> indicating the operation to be
+-    performed. The valid operations are: 
++    performed. The valid operations are:
+     <ul>
+         <li><strong><code>'+'</code></strong> to add the values to the attributes</li>
+         <li><strong><code>'-'</code></strong> to delete the values of the attributes</li>
+@@ -229,7 +229,7 @@ message provided by the OpenLDAP client.</p>
+     <dt><strong><code>conn:rename (distinguished_name, new_relative_dn,
+     new_parent)</code></strong></dt>
+     <dd>Changes an entry name (i.e. change its <a href="#dn">distinguished name</a>).</dd>
+-	
++
+     <dt><strong><code>conn:search (table_of_search_parameters)</code></strong></dt>
+     <dd>Performs a search operation on the directory. The parameters are
+     described below:<br/><br/>
+@@ -237,31 +237,31 @@ message provided by the OpenLDAP client.</p>
+         <dt><strong><code>attrs</code></strong></dt>
+ 		<dd>a string or a list of attribute names to
+         be retrieved (default is to retrieve all attributes).</dd>
+-		
++
+         <dt><strong><code>attrsonly</code></strong></dt>
+ 		<dd>a Boolean value that must be either
+         <em>false</em> (default) if both attribute names and values are to be
+         retrieved, or <em>true</em> if only names are wanted.</dd>
+-		
++
+         <dt><strong><code>base</code></strong></dt>
+ 		<dd>The <a href="#dn">distinguished name</a>
+         of the entry at which to start the search.</dd>
+-		
++
+         <dt><strong><code>filter</code></strong></dt>
+ 		<dd>A string representing the search filter
+         as described in <a href="http://www.ietf.org/rfc/rfc2254.txt">The
+         String Representation of LDAP Search Filters (RFC 2254)</a>.</dd>
+-		
++
+         <dt><strong><code>scope</code></strong></dt>
+ 		<dd>A string indicating the scope of the
+         search. The valid strings are: "base", "onelevel" and "subtree".
+         The empty string ("") and <code>nil</code> will be treated as the
+         default scope.</dd>
+-		
++
+         <dt><strong><code>sizelimit</code></strong></dt>
+ 		<dd>The maximum number of entries to
+         return (default is no limit).</dd>
+-		
++
+         <dt><strong><code>timeout</code></strong></dt>
+ 		<dd>The timeout in seconds (default is no
+         timeout). The precision is microseconds.</dd>
+@@ -342,7 +342,7 @@ ld:delete ("mydn=newuser,ou=people,dc=ldp,dc=world")()
+ 
+ <div id="about">
+ 	<p><a href="http://validator.w3.org/check?uri=referer">
+-    <img src="http://www.w3.org/Icons/valid-xhtml10" alt="Valid XHTML 1.0!" height="31" width="88" /></a></p>
++    Valid XHTML 1.0!</p>
+ 	<p><small>$Id: manual.html,v 1.34 2007-12-14 16:46:15 carregal Exp $</small></p>
+ </div> <!-- id="about" -->
+ 
diff -pruN 1.1.0-1-geeac494-6.1/debian/patches/series 1.2.3-1/debian/patches/series
--- 1.1.0-1-geeac494-6.1/debian/patches/series	2014-08-31 16:44:37.000000000 +0000
+++ 1.2.3-1/debian/patches/series	2018-12-06 23:49:54.000000000 +0000
@@ -1 +1,2 @@
 define_ldap_deprecated.diff
+0002-add-doc-css.patch
diff -pruN 1.1.0-1-geeac494-6.1/debian/watch 1.2.3-1/debian/watch
--- 1.1.0-1-geeac494-6.1/debian/watch	2014-08-31 16:44:37.000000000 +0000
+++ 1.2.3-1/debian/watch	2018-12-06 23:49:54.000000000 +0000
@@ -1,5 +1,6 @@
 # test this watch file using:
 # uscan --watchfile debian/watch --upstream-version 0.0.1 --package lua-ldap
 #
-version=3
-https://github.com/luaforge/lualdap/downloads .*/lualdap-([\d\.]*).tar.gz
+version=4
+opts="filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/lualdap_$1\.tar\.gz/" \
+  https://github.com/lualdap/lualdap/tags .*/v?(\d\.\S*)\.tar\.gz
diff -pruN 1.1.0-1-geeac494-6.1/.gitignore 1.2.3-1/.gitignore
--- 1.1.0-1-geeac494-6.1/.gitignore	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.3-1/.gitignore	2015-04-09 10:41:48.000000000 +0000
@@ -0,0 +1,6 @@
+*~
+*.bak
+*.o
+*.so
+*.so.*
+*.rock
diff -pruN 1.1.0-1-geeac494-6.1/LICENSE.md 1.2.3-1/LICENSE.md
--- 1.1.0-1-geeac494-6.1/LICENSE.md	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.3-1/LICENSE.md	2015-04-09 10:41:48.000000000 +0000
@@ -0,0 +1 @@
+The original authors and subsequent contributors released this software under the same license as [LUA](http://www.lua.org/license.html) which is simply the [MIT License](http://opensource.org/licenses/mit-license.html)
\ No newline at end of file
diff -pruN 1.1.0-1-geeac494-6.1/Makefile 1.2.3-1/Makefile
--- 1.1.0-1-geeac494-6.1/Makefile	2012-04-26 15:13:13.000000000 +0000
+++ 1.2.3-1/Makefile	2015-04-09 10:41:48.000000000 +0000
@@ -1,7 +1,7 @@
 # $Id: Makefile,v 1.30 2007-03-13 22:07:33 godinho Exp $
 
 T= lualdap
-V= 1.1.0
+V= 1.2.3
 CONFIG= ./config
 
 include $(CONFIG)
@@ -20,9 +20,9 @@ $(COMPAT_DIR)/compat-5.1.o: $(COMPAT_DIR
 	$(CC) -c $(CFLAGS) -o $@ $(COMPAT_DIR)/compat-5.1.c
 
 install: src/$(LIBNAME)
-	mkdir -p $(LUA_LIBDIR)
-	cp src/$(LIBNAME) $(LUA_LIBDIR)
-	cd $(LUA_LIBDIR); ln -f -s $(LIBNAME) $T.so
+	mkdir -p $(DESTDIR)$(LUA_LIBDIR)
+	cp src/$(LIBNAME) $(DESTDIR)$(LUA_LIBDIR)
+	cd $(DESTDIR)$(LUA_LIBDIR); ln -f -s $(LIBNAME) $T.so
 
 clean:
 	rm -f $(OBJS) src/$(LIBNAME)
diff -pruN 1.1.0-1-geeac494-6.1/Makefile.win 1.2.3-1/Makefile.win
--- 1.1.0-1-geeac494-6.1/Makefile.win	2012-04-26 15:13:13.000000000 +0000
+++ 1.2.3-1/Makefile.win	2015-04-09 10:41:48.000000000 +0000
@@ -1,5 +1,5 @@
 T= lualdap
-V= 1.1.0
+V= 1.2.3
 
 include config.win
 
diff -pruN 1.1.0-1-geeac494-6.1/README 1.2.3-1/README
--- 1.1.0-1-geeac494-6.1/README	2012-04-26 15:13:13.000000000 +0000
+++ 1.2.3-1/README	1970-01-01 00:00:00.000000000 +0000
@@ -1,28 +0,0 @@
-LuaLDAP
-(http://www.keplerproject.org/lualdap/)
-
-LuaLDAP is a simple interface from Lua to an LDAP client, in fact it is a bind to
-OpenLDAP or to ADSI. It enables a Lua program to:
-
-    * Connect to an LDAP server;
-    * Execute any operation (search, add, compare, delete, modify and rename);
-    * Retrieve entries and references of the search result.
-
-LuaLDAP is free software and uses the same license as Lua 5.1.
-
-Current version is 1.1. It was developed for both Lua 5.0 and Lua 5.1,
-and both OpenLDAP 2.1 or newer and ADSI.
-
-Files in the distribution:
-
-    /doc/us/*.html  -- Documentation
-	/src/*			-- Source files
-	/tests/*        -- Test files
-	/vc6/*          -- Build files for MS Visual C 6 (deprecated)
-    Makefile        -- Makefile for Unix systems
-    config          -- Configurations to build on Unix systems
-    Makefile.win    -- Makefile for Windows systens with MS Visual C 8
-    config.win      -- Configurations to build on Windows systems
-    README          -- This file
-
-$Id: README,v 1.7 2007-12-14 15:14:54 carregal Exp $
diff -pruN 1.1.0-1-geeac494-6.1/README.md 1.2.3-1/README.md
--- 1.1.0-1-geeac494-6.1/README.md	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.3-1/README.md	2015-04-09 10:41:48.000000000 +0000
@@ -0,0 +1,31 @@
+LuaLDAP
+(https://github.com/bdellegrazie/lualdap/)
+
+LuaLDAP is a simple interface from Lua to an LDAP client, in fact it is a bind to
+OpenLDAP or to ADSI. It enables a Lua program to:
+
+    * Connect to an LDAP server;
+    * Execute any operation (search, add, compare, delete, modify and rename);
+    * Retrieve entries and references of the search result.
+
+LuaLDAP is free software and uses the same license as Lua 5.1.
+
+Current version is 1.2.2. It was developed for both Lua 5.1 and Lua 5.2,
+and both OpenLDAP 2.1 or newer and ADSI.
+
+Files in the distribution:
+
+    /doc/us/*.html  -- Documentation
+	/src/*			-- Source files
+	/tests/*        -- Test files
+	/vc6/*          -- Build files for MS Visual C 6 (deprecated)
+    /rockspecs/         -- luarocks build system releases
+    Makefile        -- Makefile for Unix systems (deprecated)
+    config          -- Configurations to build on Unix systems (deprecated)
+    Makefile.win    -- Makefile for Windows systens with MS Visual C 8
+    config.win      -- Configurations to build on Windows systems
+    README.md       -- This file
+    CONTRIBUTORS.md -- Who contributed what
+    LICENSE.md      -- MIT License reference
+
+Please see CONTRIBUTORS for contribution information and documentation on original source
diff -pruN 1.1.0-1-geeac494-6.1/rockspecs/lualdap/lualdap-1.2.1-1.rockspec 1.2.3-1/rockspecs/lualdap/lualdap-1.2.1-1.rockspec
--- 1.1.0-1-geeac494-6.1/rockspecs/lualdap/lualdap-1.2.1-1.rockspec	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.3-1/rockspecs/lualdap/lualdap-1.2.1-1.rockspec	2015-04-09 10:41:48.000000000 +0000
@@ -0,0 +1,34 @@
+package="lualdap"
+version="1.2.1-1"
+source = {
+   url = "https://github.com/bdellegrazie/lualdap/archive/v1.2.1.tar.gz",
+   dir = "lualdap-1.2.1",
+}
+description = {
+   summary = "Simple interface from Lua to an LDAP Client",
+   detailed = [[
+      Simple interface from Lua to an LDAP client.
+   ]],
+   homepage = "https://github.com/bdellegrazie/lualdap",
+   license = "MIT"
+}
+dependencies = {
+   "lua >= 5.1, < 5.3"
+}
+external_dependencies = {
+   LIBLDAP = {
+      header = "ldap.h",
+      library = "ldap",
+   }
+}
+build = {
+   type = "builtin",
+   modules = {
+      lualdap = {
+         sources = "src/lualdap.c",
+         libdirs = "$(LIBLDAP_LIBDIR)",
+         incdirs = "$(LIBLDAP_INCDIR)",
+         libraries = "ldap",
+      },
+   }
+}
diff -pruN 1.1.0-1-geeac494-6.1/rockspecs/lualdap/lualdap-1.2.2-1.rockspec 1.2.3-1/rockspecs/lualdap/lualdap-1.2.2-1.rockspec
--- 1.1.0-1-geeac494-6.1/rockspecs/lualdap/lualdap-1.2.2-1.rockspec	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.3-1/rockspecs/lualdap/lualdap-1.2.2-1.rockspec	2015-04-09 10:41:48.000000000 +0000
@@ -0,0 +1,34 @@
+package="lualdap"
+version="1.2.2-1"
+source = {
+   url = "https://github.com/bdellegrazie/lualdap/archive/v1.2.2.tar.gz",
+   dir = "lualdap-1.2.2",
+}
+description = {
+   summary = "Simple interface from Lua to an LDAP Client",
+   detailed = [[
+      Simple interface from Lua to an LDAP client.
+   ]],
+   homepage = "https://github.com/bdellegrazie/lualdap",
+   license = "MIT"
+}
+dependencies = {
+   "lua >= 5.1, < 5.3"
+}
+external_dependencies = {
+   LIBLDAP = {
+      header = "ldap.h",
+      library = "ldap",
+   }
+}
+build = {
+   type = "builtin",
+   modules = {
+      lualdap = {
+         sources = "src/lualdap.c",
+         libdirs = "$(LIBLDAP_LIBDIR)",
+         incdirs = "$(LIBLDAP_INCDIR)",
+         libraries = "ldap",
+      },
+   }
+}
diff -pruN 1.1.0-1-geeac494-6.1/rockspecs/lualdap/lualdap-1.2.3-1.rockspec 1.2.3-1/rockspecs/lualdap/lualdap-1.2.3-1.rockspec
--- 1.1.0-1-geeac494-6.1/rockspecs/lualdap/lualdap-1.2.3-1.rockspec	1970-01-01 00:00:00.000000000 +0000
+++ 1.2.3-1/rockspecs/lualdap/lualdap-1.2.3-1.rockspec	2015-04-09 10:41:48.000000000 +0000
@@ -0,0 +1,34 @@
+package="lualdap"
+version="1.2.3-1"
+source = {
+   url = "git://github.com/bdellegrazie/lualdap",
+   tag = "v1.2.3",
+}
+description = {
+   summary = "Simple interface from Lua to an LDAP Client",
+   detailed = [[
+      Simple interface from Lua to an LDAP client.
+   ]],
+   homepage = "https://github.com/bdellegrazie/lualdap",
+   license = "MIT"
+}
+dependencies = {
+   "lua >= 5.1, < 5.3"
+}
+external_dependencies = {
+   LIBLDAP = {
+      header = "ldap.h",
+      library = "ldap",
+   }
+}
+build = {
+   type = "builtin",
+   modules = {
+      lualdap = {
+         sources = {"src/lualdap.c"},
+         libdirs = {"$(LIBLDAP_LIBDIR)"},
+         incdirs = {"$(LIBLDAP_INCDIR)"},
+         libraries = {"ldap"},
+      },
+   }
+}
diff -pruN 1.1.0-1-geeac494-6.1/src/lualdap.c 1.2.3-1/src/lualdap.c
--- 1.1.0-1-geeac494-6.1/src/lualdap.c	2012-04-26 15:13:13.000000000 +0000
+++ 1.2.3-1/src/lualdap.c	2015-04-09 10:41:48.000000000 +0000
@@ -6,6 +6,7 @@
 
 #include <stdlib.h>
 #include <string.h>
+#include <assert.h>
 
 #ifdef WIN32
 #include <Winsock2.h>
@@ -19,10 +20,14 @@
 #include "ldap.h"
 #endif
 
-#include "lua.h"
-#include "lauxlib.h"
-#if ! defined (LUA_VERSION_NUM) || LUA_VERSION_NUM < 501
-#include "compat-5.1.h"
+#include <lua.h>
+#include <lauxlib.h>
+
+#if LUA_VERSION_NUM < 502
+/* lua_rawlen: Not entirely correct, but should work anyway */
+#  define lua_rawlen lua_objlen
+#  define luaL_newlib(L,l) (lua_newtable(L), luaL_register(L,NULL,l))
+#  define luaL_setfuncs(L,l,n) (assert(n==0), luaL_register(L,NULL,l))
 #endif
 
 #ifdef WINLDAPAPI
@@ -141,9 +146,9 @@ static int option_error (lua_State *L, c
 /*
 ** Get the field called name of the table at position 2.
 */
-static void strgettable (lua_State *L, const char *name) {
+static void strgettable (lua_State *L, int idx, const char *name) {
 	lua_pushstring (L, name);
-	lua_gettable (L, 2);
+	lua_gettable (L, idx);
 }
 
 
@@ -151,8 +156,8 @@ static void strgettable (lua_State *L, c
 ** Get the field named name as a string.
 ** The table MUST be at position 2.
 */
-static const char *strtabparam (lua_State *L, const char *name, char *def) {
-	strgettable (L, name);
+static const char *strtabparam (lua_State *L, int idx, const char *name, char *def) {
+	strgettable (L, idx, name);
 	if (lua_isnil (L, -1))
 		return def;
 	else if (lua_isstring (L, -1))
@@ -168,8 +173,8 @@ static const char *strtabparam (lua_Stat
 ** Get the field named name as an integer.
 ** The table MUST be at position 2.
 */
-static long longtabparam (lua_State *L, const char *name, int def) {
-	strgettable (L, name);
+static long longtabparam (lua_State *L, int idx, const char *name, int def) {
+	strgettable (L, idx, name);
 	if (lua_isnil (L, -1))
 		return def;
 	else if (lua_isnumber (L, -1))
@@ -183,8 +188,8 @@ static long longtabparam (lua_State *L,
 ** Get the field named name as a double.
 ** The table MUST be at position 2.
 */
-static double numbertabparam (lua_State *L, const char *name, double def) {
-	strgettable (L, name);
+static double numbertabparam (lua_State *L, int idx, const char *name, double def) {
+	strgettable (L, idx, name);
 	if (lua_isnil (L, -1))
 		return def;
 	else if (lua_isnumber (L, -1))
@@ -199,7 +204,7 @@ static double numbertabparam (lua_State
 ** The table MUST be at position 2.
 */
 static int booltabparam (lua_State *L, const char *name, int def) {
-	strgettable (L, name);
+	strgettable (L, 2, name);
 	if (lua_isnil (L, -1))
 		return def;
 	else if (lua_isboolean (L, -1))
@@ -243,7 +248,7 @@ static BerValue *A_setbval (lua_State *L
 		value_error (L, n);
 		return NULL;
 	}
-	a->bvals[a->bi].bv_len = lua_strlen (L, -1);
+	a->bvals[a->bi].bv_len = lua_rawlen (L, -1);
 	a->bvals[a->bi].bv_val = (char *)lua_tostring (L, -1);
 	a->bi++;
 	return ret;
@@ -296,7 +301,7 @@ static BerValue **A_tab2val (lua_State *
 		A_setval (L, a, name);
 	else if (lua_istable (L, tab)) { /* list of strings */
 		int i;
-		int n = luaL_getn (L, tab);
+		int n = lua_rawlen (L, tab);
 		for (i = 1; i <= n; i++) {
 			lua_rawgeti (L, tab, i); /* push table element */
 			A_setval (L, a, name);
@@ -368,7 +373,7 @@ static int table2strarray (lua_State *L,
 		array[1] = NULL;
 	} else if (lua_istable (L, tab)) {
 		int i;
-		int n = luaL_getn (L, tab);
+		int n = lua_rawlen (L, tab);
 		if (limit < (n+1))
 			return luaL_error (L, LUALDAP_PREFIX"too many arguments");
 		for (i = 0; i < n; i++) {
@@ -387,13 +392,25 @@ static int table2strarray (lua_State *L,
 
 
 /*
+** Fill in the struct timeval, according to the timeout parameter.
+*/
+static struct timeval *get_timeout_param (lua_State *L, int idx, struct timeval *st) {
+	double t = numbertabparam (L, idx, "timeout", -1);
+	if(t < 0)
+		return NULL; /* No timeout, block */
+	st->tv_sec = (long)t;
+	st->tv_usec = (long)(1000000 * (t - st->tv_sec));
+	return st;
+}
+
+/*
 ** Get the result message of an operation.
 ** #1 upvalue == connection
 ** #2 upvalue == msgid
 ** #3 upvalue == result code of the message (ADD, DEL etc.) to be received.
 */
 static int result_message (lua_State *L) {
-	struct timeval *timeout = NULL; /* ??? function parameter ??? */
+	struct timeval timeout;
 	LDAPMessage *res;
 	int rc;
 	conn_data *conn = (conn_data *)lua_touserdata (L, lua_upvalueindex (1));
@@ -401,7 +418,7 @@ static int result_message (lua_State *L)
 	/*int res_code = (int)lua_tonumber (L, lua_upvalueindex (3));*/
 
 	luaL_argcheck (L, conn->ld, 1, LUALDAP_PREFIX"LDAP connection is closed");
-	rc = ldap_result (conn->ld, msgid, LDAP_MSG_ONE, timeout, &res);
+	rc = ldap_result (conn->ld, msgid, LDAP_MSG_ONE, get_timeout_param (L, 1, &timeout), &res);
 	if (rc == 0)
 		return faildirect (L, LUALDAP_PREFIX"result timeout expired");
 	else if (rc < 0) {
@@ -424,10 +441,14 @@ static int result_message (lua_State *L)
 			default:
 				lua_pushnil (L);
 				lua_pushliteral (L, LUALDAP_PREFIX);
-				lua_pushstring (L, msg);
-				lua_pushliteral (L, " ");
 				lua_pushstring (L, ldap_err2string(err));
-				lua_concat (L, 4);
+				lua_concat (L, 2);
+				if (msg != NULL) {
+					lua_pushliteral (L, " (");
+					lua_pushstring (L, msg);
+					lua_pushliteral (L, ")");
+					lua_concat (L, 4);
+				}
 				ret = 2;
 		}
 		ldap_memfree (mdn);
@@ -450,7 +471,6 @@ static int create_future (lua_State *L,
 	return 1;
 }
 
-
 /*
 ** Unbind from the directory.
 ** @param #1 LDAP connection.
@@ -461,7 +481,11 @@ static int lualdap_close (lua_State *L)
 	luaL_argcheck(L, conn!=NULL, 1, LUALDAP_PREFIX"LDAP connection expected");
 	if (conn->ld == NULL) /* already closed */
 		return 0;
+#if defined(LDAP_API_FEATURE_X_OPENLDAP) && LDAP_API_FEATURE_X_OPENLDAP >= 20300
+	ldap_unbind_ext (conn->ld, NULL, NULL);
+#else
 	ldap_unbind (conn->ld);
+#endif
 	conn->ld = NULL;
 	lua_pushnumber (L, 1);
 	return 1;
@@ -469,6 +493,37 @@ static int lualdap_close (lua_State *L)
 
 
 /*
+** Bind to the directory.
+** @param #1 LDAP connection.
+** @param #2 String with username.
+** @param #3 String with password.
+** @return Boolean.
+*/
+static int lualdap_bind_simple (lua_State *L) {
+	conn_data *conn = getconnection (L);
+	ldap_pchar_t who = (ldap_pchar_t) luaL_checkstring (L, 2);
+	const char *password = luaL_checkstring (L, 3);
+	int err;
+#if defined(LDAP_API_FEATURE_X_OPENLDAP) && LDAP_API_FEATURE_X_OPENLDAP >= 20300
+	struct berval cred = { 0, NULL };
+	cred.bv_len = strlen(password);
+	cred.bv_val = malloc(cred.bv_len+1);
+	strcpy(cred.bv_val, password);
+	err = ldap_sasl_bind_s (conn->ld, who, LDAP_SASL_SIMPLE, &cred, NULL, NULL, NULL);
+	free(cred.bv_val);
+	memset(&cred, 0, sizeof(cred));
+#else
+	err = ldap_simple_bind_s (conn->ld, who, password);
+#endif
+	if (err != LDAP_SUCCESS)
+		return faildirect (L, ldap_err2string (err));
+	
+	lua_pushboolean (L, 1);
+	return 1;
+}
+
+
+/*
 ** Add a new entry to the directory.
 ** @param #1 LDAP connection.
 ** @param #2 String with new entry's DN.
@@ -504,7 +559,7 @@ static int lualdap_compare (lua_State *L
 	BerValue bvalue;
 	ldap_int_t rc, msgid;
 	bvalue.bv_val = (char *)luaL_checkstring (L, 4);
-	bvalue.bv_len = lua_strlen (L, 4);
+	bvalue.bv_len = lua_rawlen (L, 4);
 	rc = ldap_compare_ext (conn->ld, dn, attr, &bvalue, NULL, NULL, &msgid);
 	return create_future (L, rc, 1, msgid, LDAP_RES_COMPARE);
 }
@@ -666,15 +721,17 @@ static void search_close (lua_State *L,
 static int next_message (lua_State *L) {
 	search_data *search = getsearch (L);
 	conn_data *conn;
-	struct timeval *timeout = NULL; /* ??? function parameter ??? */
+	struct timeval timeout;
 	LDAPMessage *res;
 	int rc;
 	int ret;
 
+	luaL_checktype(L, 1, LUA_TTABLE);
+
 	lua_rawgeti (L, LUA_REGISTRYINDEX, search->conn);
 	conn = (conn_data *)lua_touserdata (L, -1); /* get connection */
 
-	rc = ldap_result (conn->ld, search->msgid, LDAP_MSG_ONE, timeout, &res);
+	rc = ldap_result (conn->ld, search->msgid, LDAP_MSG_ONE, get_timeout_param (L, 1, &timeout), &res);
 	if (rc == 0)
 		return faildirect (L, LUALDAP_PREFIX"result timeout expired");
 	else if (rc == -1)
@@ -784,20 +841,6 @@ static int get_attrs_param (lua_State *L
 
 
 /*
-** Fill in the struct timeval, according to the timeout parameter.
-*/
-static struct timeval *get_timeout_param (lua_State *L, struct timeval *st) {
-	double t = numbertabparam (L, "timeout", 0);
-	st->tv_sec = (long)t;
-	st->tv_usec = (long)(1000000 * (t - st->tv_sec));
-	if (st->tv_sec == 0 && st->tv_usec == 0)
-		return NULL;
-	else
-		return st;
-}
-
-
-/*
 ** Perform a search operation.
 ** @return #1 Function to iterate over the result entries.
 ** @return #2 nil.
@@ -818,11 +861,11 @@ static int lualdap_search (lua_State *L)
 		return 2;
 	/* get other parameters */
 	attrsonly = booltabparam (L, "attrsonly", 0);
-	base = (ldap_pchar_t) strtabparam (L, "base", NULL);
-	filter = (ldap_pchar_t) strtabparam (L, "filter", NULL);
-	scope = string2scope (L, strtabparam (L, "scope", NULL));
-	sizelimit = longtabparam (L, "sizelimit", LDAP_NO_LIMIT);
-	timeout = get_timeout_param (L, &st);
+	base = (ldap_pchar_t) strtabparam (L, 2, "base", NULL);
+	filter = (ldap_pchar_t) strtabparam (L, 2, "filter", NULL);
+	scope = string2scope (L, strtabparam (L, 2, "scope", NULL));
+	sizelimit = longtabparam (L, 2, "sizelimit", LDAP_NO_LIMIT);
+	timeout = get_timeout_param (L, 2, &st);
 
 	rc = ldap_search_ext (conn->ld, base, scope, filter, attrs, attrsonly,
 		NULL, NULL, timeout, sizelimit, &msgid);
@@ -831,7 +874,8 @@ static int lualdap_search (lua_State *L)
 
 	create_search (L, 1, msgid);
 	lua_pushcclosure (L, next_message, 1);
-	return 1;
+	lua_pushvalue(L, 2);
+	return 2;
 }
 
 
@@ -872,8 +916,9 @@ static int lualdap_search_tostring (lua_
 ** Create a metatable.
 */
 static int lualdap_createmeta (lua_State *L) {
-	const luaL_reg methods[] = {
+	const luaL_Reg methods[] = {
 		{"close", lualdap_close},
+		{"bind_simple", lualdap_bind_simple},
 		{"add", lualdap_add},
 		{"compare", lualdap_compare},
 		{"delete", lualdap_delete},
@@ -887,7 +932,7 @@ static int lualdap_createmeta (lua_State
 		return 0;
 
 	/* define methods */
-	luaL_openlib (L, NULL, methods, 0);
+	luaL_setfuncs(L, methods, 0);
 
 	/* define metamethods */
 	lua_pushliteral (L, "__gc");
@@ -926,6 +971,34 @@ static int lualdap_createmeta (lua_State
 
 
 /*
+** Open and initialize a connection to a server (without binding).
+** @param #1 String with URI.
+** @return #1 Userdata with connection structure.
+*/
+static int lualdap_initialize (lua_State *L) {
+	ldap_pchar_t uri = (ldap_pchar_t) luaL_checkstring (L, 1);
+	conn_data *conn = (conn_data *)lua_newuserdata (L, sizeof(conn_data));
+	int err;
+	int lev=7;
+
+	/* Initialize */
+	lualdap_setmeta (L, LUALDAP_CONNECTION_METATABLE);
+	conn->version = 0;
+	err = ldap_initialize (&conn->ld, uri);
+	if (err != LDAP_SUCCESS)
+		return faildirect(L, ldap_err2string(err));
+	
+	/* Set protocol version */
+	conn->version = LDAP_VERSION3;
+	if (ldap_set_option (conn->ld, LDAP_OPT_PROTOCOL_VERSION, &conn->version)
+		!= LDAP_OPT_SUCCESS)
+		return faildirect(L, LUALDAP_PREFIX"Error setting LDAP version");
+	ldap_set_option(conn->ld, LDAP_OPT_DEBUG_LEVEL, &lev);
+
+	return 1;
+}
+
+/*
 ** Open and initialize a connection to a server.
 ** @param #1 String with hostname.
 ** @param #2 String with username.
@@ -939,13 +1012,27 @@ static int lualdap_open_simple (lua_Stat
 	const char *password = luaL_optstring (L, 3, NULL);
 	int use_tls = lua_toboolean (L, 4);
 	conn_data *conn = (conn_data *)lua_newuserdata (L, sizeof(conn_data));
+#if defined(LDAP_API_FEATURE_X_OPENLDAP) && LDAP_API_FEATURE_X_OPENLDAP >= 20300
+	struct berval cred = { 0, NULL };
+	char *host_with_schema = NULL;
+#endif
 	int err;
 
 	/* Initialize */
 	lualdap_setmeta (L, LUALDAP_CONNECTION_METATABLE);
 	conn->version = 0;
+#if defined(LDAP_API_FEATURE_X_OPENLDAP) && LDAP_API_FEATURE_X_OPENLDAP >= 20300
+	host_with_schema = malloc(strlen(host) + 8);
+	strcpy(host_with_schema, "ldap://");
+	strcat(host_with_schema, host);
+	err = ldap_initialize(&conn->ld, host_with_schema);
+	free(host_with_schema);
+	host_with_schema = NULL;
+	if (err != LDAP_SUCCESS)
+#else
 	conn->ld = ldap_init (host, LDAP_PORT);
 	if (conn->ld == NULL)
+#endif
 		return faildirect(L,LUALDAP_PREFIX"Error connecting to server");
 	/* Set protocol version */
 	conn->version = LDAP_VERSION3;
@@ -959,7 +1046,16 @@ static int lualdap_open_simple (lua_Stat
 			return faildirect (L, ldap_err2string (rc));
 	}
 	/* Bind to a server */
+#if defined(LDAP_API_FEATURE_X_OPENLDAP) && LDAP_API_FEATURE_X_OPENLDAP >= 20300
+	cred.bv_len = strlen(password);
+	cred.bv_val = malloc(cred.bv_len+1);
+	strcpy(cred.bv_val, password);
+	err = ldap_sasl_bind_s (conn->ld, who, LDAP_SASL_SIMPLE, &cred, NULL, NULL, NULL);
+	free(cred.bv_val);
+	memset(&cred, 0, sizeof(cred));
+#else
 	err = ldap_bind_s (conn->ld, who, password, LDAP_AUTH_SIMPLE);
+#endif
 	if (err != LDAP_SUCCESS)
 		return faildirect (L, ldap_err2string (err));
 
@@ -978,7 +1074,7 @@ static void set_info (lua_State *L) {
 	lua_pushliteral (L, "LuaLDAP is a simple interface from Lua to an LDAP client");
 	lua_settable (L, -3);
 	lua_pushliteral (L, "_VERSION");
-	lua_pushliteral (L, "LuaLDAP 1.1.1");
+	lua_pushliteral (L, "LuaLDAP 1.2.2");
 	lua_settable (L, -3);
 }
 
@@ -987,13 +1083,16 @@ static void set_info (lua_State *L) {
 ** Create ldap table and register the open method.
 */
 int luaopen_lualdap (lua_State *L) {
-	struct luaL_reg lualdap[] = {
+	struct luaL_Reg lualdap[] = {
+		{"initialize", lualdap_initialize},
 		{"open_simple", lualdap_open_simple},
 		{NULL, NULL},
 	};
 
 	lualdap_createmeta (L);
-	luaL_openlib (L, LUALDAP_TABLENAME, lualdap, 0);
+	luaL_newlib(L, lualdap);
+	lua_pushvalue(L, -1);
+	lua_setglobal(L, LUALDAP_TABLENAME);
 	set_info (L);
 
 	return 1;
diff -pruN 1.1.0-1-geeac494-6.1/src/lualdap.def 1.2.3-1/src/lualdap.def
--- 1.1.0-1-geeac494-6.1/src/lualdap.def	2012-04-26 15:13:13.000000000 +0000
+++ 1.2.3-1/src/lualdap.def	2015-04-09 10:41:48.000000000 +0000
@@ -1,6 +1,6 @@
 LIBRARY lualdap.dll
 DESCRIPTION "LuaLDAP"
-VERSION 1.1.1
+VERSION 1.2.3
 EXPORTS
 luaopen_lualdap
 
diff -pruN 1.1.0-1-geeac494-6.1/tests/test.lua 1.2.3-1/tests/test.lua
--- 1.1.0-1-geeac494-6.1/tests/test.lua	2012-04-26 15:13:13.000000000 +0000
+++ 1.2.3-1/tests/test.lua	2015-04-09 10:41:48.000000000 +0000
@@ -1,4 +1,4 @@
-#!/usr/local/bin/lua5.1
+#!/usr/bin/env lua5.1
 ---------------------------------------------------------------------
 -- LuaLDAP test file.
 -- This test will create a copy of an existing entry on the
